package org.xiss.examples;

import net.sf.xanswer.indexing.IndexException;

import org.xiss.index.IXissIndex;
import org.xiss.index.XissIndexFactory;

public class BuildIndex {
	public static void main(String[] args) {
		if (args.length != 2) {
			System.out.println("Usage: BuildIndex <XmlFile> <Directory>");
			System.out.println("XmlFile - the file to index");
			System.out.println("Directory - the directory to put files into");
			return;
		}

		XissIndexFactory factory = XissIndexFactory.newInstance();
		IXissIndex index = null;
		try {
			long start = System.currentTimeMillis();
			
			index = factory.createNewFromDocument(args[0], args[1]);
			long end = System.currentTimeMillis();
			System.out.println("Index creation took "+(end-start)+"ms");
			System.out.println("Index created successfully: "
					+ index.getTotalNodesCount() + " nodes indexed, "+
					(int)(1000.0*index.getTotalNodesCount()/(end-start))+" nodes/sec");
			index.close();
		} catch (IndexException e) {
			System.out.println("Error creating index: " + e.getMessage());
			System.out.println("Error stack trace follows:");
			e.printStackTrace(System.out);
			return;
		}
		
	}
}
