package org.xiss.query;

import java.util.List;

/**
 * A factory for parsing queries
 */
public interface IQueryFactory {
	/**
	 * Parse a query string into a query
	 */
	IQuery parse(String query) throws QueryParseException;

	/**
	 * Create a query from a plan
	 */
	IQuery createFromPlan(List<IXissOperation> plan);
}
