package org.xiss.query.impl;

import java.util.Iterator;

import org.xiss.index.IXissIndex;
import org.xiss.query.Chunk;
import org.xiss.query.IResultNode;

public class Chunks2NodesAdapter implements Iterable<IResultNode> {
	private ChunkList myChunkList;

	private IXissIndex myIndex;

	public Chunks2NodesAdapter(IXissIndex index, ChunkList chunkList) {
		myIndex = index;
		myChunkList = chunkList;
	}

	public Iterator<IResultNode> iterator() {
		return new NodesIterator();
	}

	private class NodesIterator implements Iterator<IResultNode> {
		private Iterator<Chunk> myIterator;

		public NodesIterator() {
			myIterator = myChunkList.getChunks().listIterator();
		}

		public boolean hasNext() {
			return myIterator.hasNext();
		}

		public IResultNode next() {
			return new NodeFromIndex(myIndex, myIterator.next().End.Id);
		}

		public void remove() {
			throw new UnsupportedOperationException();
		}
	}
}
