package org.xiss.query.impl;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.xiss.index.ElementIndexEntry;
import org.xiss.index.IXissIndex;
import org.xiss.query.Chunk;
import org.xiss.query.IResult;
import org.xiss.query.IResultNode;

/**
 * Represents a single node of the indexed XML file
 */
public class SingleNodeResult extends AbstractResult {
	private ElementIndexEntry myEntry;

	public SingleNodeResult(ElementIndexEntry nodeEntry) {
		myEntry = nodeEntry;
	}

	public List<Chunk> getChunks() {
		LinkedList<Chunk> list = new LinkedList<Chunk>();
		list.add(new Chunk(myEntry, myEntry));
		return list;
	}

	public boolean isSortedByStart() {
		return true;
	}

	public boolean isSortedByEnd() {
		return true;
	}

	public boolean isEmpty() {
		return false;
	}

	public Iterable<IResultNode> getNodes(IXissIndex index) {
		List<IResultNode> res = new ArrayList<IResultNode>(1);
		res.add(new NodeFromIndex(index, 0));
		return res;
	}

	public IResultNode getFirstNode(IXissIndex index) {
		return new NodeFromIndex(index, 0);
	}

	public void sortByStart() {
	}

	public void sortByEnd() {
	}

	public IResult copy() {
		return new SingleNodeResult(myEntry);
	}
}