package org.xiss.index.impl.persistence;

import junit.framework.Assert;
import junit.framework.TestCase;
import net.sf.xanswer.storage.map.PersistentException;

import org.xiss.map.BTreeFactory;
import org.xiss.map.PersistentBTreeFactory;

public class BTreeTest extends TestCase {
	public void testTree() {
		BTreeFactory<Integer, String> factory = new PersistentBTreeFactory<Integer, String>();
		try {
			GenericBTree<Integer, String> tree = (GenericBTree<Integer, String>) factory
					.create("test", "BTreeTest");

			for (int i = 0; i < 16; ++i) {
				tree.put(i, "" + i * 10);
			}

			for (int i = 0; i < 16; ++i) {
				Assert.assertEquals(tree.get(i), "" + i * 10);
			}

			for (int i = 16; i < 3200; ++i) {
				tree.put(i, "" + i * 10);
			}

			for (int i = 16; i < 3200; ++i) {
				Assert.assertEquals(tree.get(i), "" + i * 10);
			}

			tree.close();
			tree.open();

			for (int i = 16; i < 3200; ++i) {
				Assert.assertEquals(tree.get(i), "" + i * 10);
			}
		} catch (PersistentException e) {
			Assert.fail(e.getMessage());
		}
	}
}
